MODULE lauflst2;
(* C: Broser 1.7.89 *)
(*    Beispiel einer linearen einfach verketteten, sortierten Liste   *)
(*               iterative und rekursive Programmierung               *)
(*                                                                    *)
(* Es sollen Nachname und Laufzeit von beliebig vielen Lufern nach-  *)
(* einander von der Tastatur in eine einfach verkettete lineare Liste *)
(* so eingegeben werden, da die Liste nach den Zeiten sortiert ist.  *)
(* In der Liste soll man nach dem Schlssel "Zeit" Datenstze suchen  *)
(* und lschen knnen. Die sortierte Liste soll am Bildschirm ausge-  *)
(* geben werden knnen.                                               *)

FROM InOut
     IMPORT WriteString, WriteLn, ReadString, Read;
FROM RealInOut
     IMPORT WriteReal, ReadReal;
FROM formatausgabe
     IMPORT WriteRText,WriteLText, WriteRReal;
FROM Storage
     IMPORT ALLOCATE,DEALLOCATE;

TYPE STRING = ARRAY[0..25] OF CHAR;
     tZeiger = POINTER TO Datensatz;
     Datensatz = RECORD
                   Name:   STRING;
                   Zeit:   REAL;
                   Next:   tZeiger;
                 END;

VAR anker : tZeiger;

PROCEDURE ErzeugeDatensatz(VAR z: tZeiger);
   BEGIN
     NEW(z);
     WriteString('Name :  '); ReadString(z^.Name); WriteLn;
     WriteString('Zeit :  '); ReadReal(z^.Zeit); WriteLn;
     z^.Next := NIL;
   END ErzeugeDatensatz;

(************* rekursive Programmierung      ************************)
(*
PROCEDURE Sortieren(VAR wurzel:tZeiger; neu:tZeiger);
   BEGIN
     IF wurzel = NIL THEN wurzel := neu
     ELSIF wurzel^.Zeit < neu^.Zeit THEN Sortieren(wurzel^.Next,neu)
     ELSE neu^.Next:=wurzel; wurzel := neu
     END; (* of IF *)
   END FuegeEin;

PROCEDURE ListeErzeugen(VAR wurzel : tZeiger);
   VAR
       antwort : CHAR;
       neu     : tZeiger;
   BEGIN
     wurzel := NIL;
     REPEAT
       ErzeugeDatensatz(neu);
       Sortieren(wurzel,neu);
       WriteString('weitere Eingabe (j/n) ? ');
       Read(antwort); WriteLn;
     UNTIL antwort <> 'j';
   END ListeErzeugen;
  *)
(*******************************************************************)
(*****************   iterative Programmierung   ********************)

PROCEDURE Sortieren( VAR wurzel: tZeiger;neu:tZeiger);
   VAR
      aktuell : tZeiger;
      zwerg1  : STRING;
      zwerg2  : REAL;

   BEGIN
     aktuell := wurzel;
     WHILE (aktuell^.Next <> NIL) AND (neu^.Zeit > aktuell^.Zeit)
          DO aktuell := aktuell^.Next   END; (* of WHILE *)
     IF neu^.Zeit < aktuell^.Zeit
        THEN
           zwerg1 :=aktuell^.Name; zwerg2 := aktuell^.Zeit;
           aktuell^.Name := neu^.Name; aktuell^.Zeit:= neu^.Zeit;
           neu^.Name := zwerg1; neu^.Zeit := zwerg2;
        END; (* of IF *)
     neu^.Next := aktuell^.Next;
     aktuell^.Next := neu;
   END Sortieren;


PROCEDURE ListeErzeugen(VAR wurzel : tZeiger);
   VAR
       antwort : CHAR;
       neu     : tZeiger;
   BEGIN
     ErzeugeDatensatz(wurzel);
     REPEAT
       ErzeugeDatensatz(neu);
       Sortieren(wurzel,neu);
       WriteString('weitere Eingabe (j/n) ? ');
       Read(antwort); WriteLn;
     UNTIL antwort <> 'j';
   END ListeErzeugen;

(*******************************************************************)

(********************* Suchen in der Liste  ************************)

PROCEDURE Suche(wurzel:tZeiger; schluessel: REAL);
   BEGIN
     IF wurzel = NIL
        THEN
          WriteString('Suchwert ist nicht in der Liste vorhanden!');
          WriteLn
        ELSIF wurzel^.Zeit = schluessel
        THEN
          WriteString('Suchwert wurde gefunden!');
          WriteLn
        ELSE Suche(wurzel^.Next,schluessel);
     END; (* of IF *)
   END Suche;

(*******************************************************************)

(********************* Loeschen in der Liste ***********************)

PROCEDURE Loesche(VAR wurzel:tZeiger; schluessel: REAL);
   VAR
      hilf : tZeiger;
   BEGIN
     IF wurzel = NIL
        THEN
          WriteString('Suchwert ist nicht in der Liste vorhanden!');
          WriteLn
        ELSIF wurzel^.Zeit = schluessel
        THEN
          hilf := wurzel;
          wurzel:= wurzel^.Next;
          DISPOSE(hilf);
          WriteString('Suchwert ist geloescht!');
          WriteLn
        ELSE Loesche(wurzel^.Next,schluessel);
     END; (* of IF *)
   END Loesche;

(*******************************************************************)

PROCEDURE ListeAusgeben(wurzel: tZeiger);
   BEGIN
     IF wurzel <> NIL
     THEN
       WriteRReal(wurzel^.Zeit,2,20);
       WriteRText(wurzel^.Name,20);
       WriteLn;
       ListeAusgeben(wurzel^.Next);
     END; (* of IF *)
   END ListeAusgeben;

PROCEDURE Menue;
   VAR schluessel : REAL;
       auswahl  : CHAR;
   BEGIN
      WriteLn;WriteLn;WriteLn;WriteLn;
      REPEAT
        WriteString('Liste erzeugen        :  1');WriteLn;
        WriteString('In Liste suchen       :  2');WriteLn;
        WriteString('Listeelement loeschen :  3');WriteLn;
        WriteString('Liste ausgeben        :  4');WriteLn;
        WriteString('Programmende          :  5');WriteLn;
        WriteLn;
        WriteString('Bitte 1,2,3,4 oder 5 eingeben :');
        Read(auswahl); WriteLn;WriteLn;
        CASE auswahl OF
           '1': ListeErzeugen(anker)|
           '2': WriteString('Bitte Suchzeit eingeben : ');
                ReadReal(schluessel);
                Suche(anker,schluessel)|
           '3': WriteString('Bitte Loeschzeit eingeben : ');
                ReadReal(schluessel);
                Loesche(anker,schluessel)|
           '4': ListeAusgeben(anker)
         ELSE
         END; (* of CASE *)
       UNTIL auswahl = '5';
     END Menue;


BEGIN  (* Hauptprogramm *)
  Menue
END lauflst2.

